#include <ESP8266WiFi.h>

#define led 2 //发光二极管连接在8266的GPIO2上
const char *ssid     = "yckj01";//这里写入网络的ssid
const char *password = "yckj2015";//wifi密码
const char *host = "192.168.0.184";//修改为Server服务端的IP，即你电脑的IP，确保在同一网络之下。

WiFiClient client;
const int tcpPort = 10002;//修改为你建立的Server服务端的端口号，此端口号是创建服务器时指定的。
int LEDPin = 13;

void setup()
{
  Serial.begin(115200);
  pinMode(led, OUTPUT);
  pinMode(LEDPin, OUTPUT);       //设置引脚模式
  delay(10);
  Serial.println();
  Serial.print("Connecting to ");//会通过usb转tll模块发送到电脑，通过ide集成的串口监视器可以获取数据。
  Serial.println(ssid);

  WiFi.begin(ssid, password);//启动

  //在这里检测是否成功连接到目标网络，未连接则阻塞。
  while (WiFi.status() != WL_CONNECTED)
  {
    //    delay(500);
    digitalWrite(LEDPin, HIGH);     //设置引脚输出高电平或低电平
    //13引脚为高电平
    delay(300);      //延时1秒
    digitalWrite(LEDPin, LOW);
    delay(300);
  }

  //几句提示
  Serial.println("");
  Serial.println("WiFi connected");
  Serial.println("IP address: ");
  Serial.println(WiFi.localIP());
}


void loop()
{
  while (!client.connected())//若未连接到服务端，则客户端进行连接。
  {

    if (!client.connect(host, tcpPort))//实际上这一步就在连接服务端，如果连接上，该函数返回true
    {
      //delay(500);
      digitalWrite(LEDPin, HIGH);     //设置引脚输出高电平或低电平
      //13引脚为高电平
      //delay(1000);      //延时1秒
      digitalWrite(LEDPin, LOW);
      // delay(500);
      Serial.println("connection....");
      // delay(500);

    }
  }
  String inputString = "";
  while (Serial.available()) {
    inputString  = inputString + char( Serial.read());
    delay(2);
  }
  if (inputString.length() > 0) {
    Serial.println("inputString:" + inputString); //把字符串传给串口
    client.print("inputString:" + inputString + "\r\n"); //向服务器反馈信息
  }

  while (client.available())//available()表示是否可以获取到数据
  {
    String line = client.readStringUntil('\r\n');//获取字符串
    Serial.println(line);//把字符串传给串口
    client.print("got it \r\n");//向服务器反馈信息
  }


}
